// ============================= CPUʱȭ ͷƮ =========================
//      : CPU  ϰ ͷƮ  ƾ .
// ----------------------------------------------------------------------------
//   
#define RXB8 1
#define TXB8 0
#define UPE 2
#define OVR 3
#define FE 4
#define UDRE 5
#define RXC 7

#define FRAMING_ERROR (1<<FE)
#define PARITY_ERROR (1<<UPE)
#define DATA_OVERRUN (1<<OVR)
#define DATA_REGISTER_EMPTY (1<<UDRE)
#define RX_COMPLETE (1<<RXC)

// Լ 
int putchar_0(char data);					// COM1 ۽
int getchar_0(void);						// COM1 

//  
char com1_rx_data,com1_rx_eflg = 0;				// COM1   ͷƮ  /÷
char com2_rx_data[50],com2_rx_eflg = 0;				// COM2   ͷƮ  /÷
int com2_rx_usi = 0,com2_rx_udi = 0;				// COM2   

int timer0_base_cnt = 0;					// Ÿ̸0 ͷƮ  ī
int timer0_tx_cnt = 0;						// Ÿ̸0 ſ ī

// ===================================== CPUʱȭ ============================
// [μ] void
// ----------------------------------------------------------------------------
void cpu_setup(void)
{

// PortA 
	PORTA=0x00;						// Ʈ  reg
	DDRA=0x00;						// Ʈ  reg(0Է,1)
// PortB 
	PORTB=0x00;						// Ʈ  reg
	DDRB=0x00;						// Ʈ  reg(0Է,1)

// PortC 
	PORTC=0x00;						// Ʈ  reg             
	DDRC=0x00;                                              // Ʈ  reg(0Է,1)

// PortD 
	PORTD=0x00;						// Ʈ  reg             
	DDRD=0x00;                                              // Ʈ  reg(0Է,1)

// PortE 
// PORTE.6(OUT) : RST\(L:,H:Reset)
// PORTE.7(OUT) : Sleep( L)
	PORTE=0x40;						// Ʈ  reg             
	DDRE=0xc0;                                              // Ʈ  reg(0Է,1)
	
// PortF 
	PORTF=0x00;						// Ʈ  reg             
	DDRF=0x00;                                              // Ʈ  reg(0Է,1)
// PortG 
	PORTG=0x00;						// Ʈ  reg             
	DDRG=0x00;                                              // Ʈ  reg(0Է,1)

// Timer/Counter0 
	ASSR=0x00;
	TCCR0 = 0x07;						// system clock,8,000,000 / 1024 = 7.8125Khz
	TCNT0 = 99;						// 255-156 = 99	
	OCR0=0x00;

// Timer/Counter1 
	TCCR1A=0x00;
	TCCR1B=0x00;
	TCNT1H=0x00;
	TCNT1L=0x00;
	OCR1AH=0x00;
	OCR1AL=0x00;
	OCR1BH=0x00;
	OCR1BL=0x00;
	OCR1CH=0x00;
	OCR1CL=0x00;

// Timer/Counter2 
	TCCR2=0x00;
	TCNT2=0x00;
	OCR2=0x00;

// Timer/Counter3 
	TCCR3A=0x00;
	TCCR3B=0x00;
	TCNT3H=0x00;
	TCNT3L=0x00;
	OCR3AH=0x00;
	OCR3AL=0x00;
	OCR3BH=0x00;
	OCR3BL=0x00;
	OCR3CH=0x00;
	OCR3CL=0x00;

// External Interrupt(s) 
// INT0: Off
// INT1: Off
// INT2: Off
// INT3: Off
// INT4: Off
// INT5: Off
// INT6: Off
// INT7: Off
	EICRA=0x00;
	EICRB=0x00;
	EIMSK=0x00;

// Timer(s)/Counter(s) Interrupt(s) 
	TIMSK |= 0x01;						// TIMER0 ͷƮ 㰡
	ETIMSK=0x00;

//  ʱȭ(COM1)
// 19200Bps, 8Data, 1 Stop, No Parity
	UCSR0A=0x00;
	UCSR0B=0x98;
	UCSR0C=0x06;
	UBRR0H=0x00;
	UBRR0L=0x33;

//  ʱȭ(COM2)
// 9600Bps, 8Data, 1 Stop, No Parity
	UCSR1A=0x00;
	UCSR1B=0x98;
	UCSR1C=0x06;
	UBRR1H=0x00;
	UBRR1L=0x67;

// External SRAM page configuration:
//              -              / 0000h - FFFFh
// Lower page wait state(s): None
// Upper page wait state(s): None
//	MCUCR=0x80;
//	XMCRA=0x00;

// Analog Comparator 
	ACSR=0x80;
	SFIOR=0x00;

	fdevopen(putchar_0,getchar_0,0);			// printf() COM1 
// Global enable interrupts
	sei();
}

// =============================== COM1 ͷƮ ===========================
// [μ] void
// ----------------------------------------------------------------------------
SIGNAL(SIG_UART0_RECV)
{
char status,data;

	status=UCSR0A;
	data=UDR0;
	if((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0){//  ˻
		com1_rx_data = data;				//  
		com1_rx_eflg = 1;				// ÷ ON
	}

}

// ============================== COM2  ͷƮ ===========================
// [μ] void
//        SLAVE  ͷƮ ó
// ----------------------------------------------------------------------------
SIGNAL(SIG_UART1_RECV)
{
char status,data;

	status=UCSR1A;
	data=UDR1;
	if((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0){
		if(com2_rx_eflg == 0){				//    ó ƴҶ
			if(data == STX){			//  ڵ ã
				com2_rx_usi = 0;		//   Ŭ
				com2_rx_data[com2_rx_usi++] = data;// STX 
			}
			else if(data == ETX){			//  ڵ ã
				com2_rx_data[com2_rx_usi++] = data;// ETX 
				com2_rx_data[com2_rx_usi] = 0;	// NULL  
				com2_rx_udi = com2_rx_usi;	//   ( ó )
				com2_rx_eflg = 1;		//  Ϸ ÷ ON( ó )
				com2_rx_usi = 0;		//   Ŭ
			}
			else{
				com2_rx_data[com2_rx_usi++] = data;//  
				if(com2_rx_usi >= 45) com2_rx_usi = 0;//  ʰ ˻			
			}
		}
	}
}

// ========================== TIMER0 overflow ͷƮ ========================
// [μ] void
// [] 16,000,000 / 1024 / 156 =  1 / 100.1602564 = 9.9984ms
// ----------------------------------------------------------------------------
SIGNAL(SIG_OVERFLOW0)
{
	TCNT0 = 99;						// 255-156 = 100
	timer0_base_cnt++;					// Ÿ̸0 ⺻   ī 10ms
	timer0_tx_cnt++;					// Ÿ̸0 ſ ī 10ms
}

// ============================== COM1 1Ʈ ۽ =========================
// [μ] char data
// item1:  
// --------------------------------------------------------------------------
int putchar_0(char data)
{
	if(data == '\n'){
		while((UCSR0A & DATA_REGISTER_EMPTY) == 0);
		UDR0 = '\r';
	}
	while((UCSR0A & DATA_REGISTER_EMPTY) == 0);
	UDR0 = data;
	return(0);
}

// ============================== COM1 1Ʈ  =========================
// [μ] void
// []  
// --------------------------------------------------------------------------
int getchar_0(void)
{
	while((UCSR0A & RX_COMPLETE) == 0);
	return(UDR0);
}
