// =========================== MEGA128 ZigBee Slave1 α׷ =================
//  CPU : ATmega128-16M
//     ¥ : 2006-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : AvrStudio
//      : Master/SLAVE1/SLAVE2  
//            COM1-RS232(PC)    : 19200,N,8,1
//            COM2-RS485(XBee)  : 9600,N,8,1
//
// PortE.6(OUT) : RST\(L:,H:Reset)
// PortE.7(OUT) : XBee Sleep(0:NON,1:SLEEP) ::    .
// ----------------------------------------------------------------------------
//  
#define	__STDIO_FDEVOPEN_COMPAT_12

#define	STX		0x02					// COM  ڵ
#define	ETX		0x03					// COM    ڵ
#define	SLAVE_NUM	'2'					// SLAVE ȣ('1' -  '2')

// ⺻ 
// === AVR includes ===
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
//#include <float.h>
//#include <math.h>

#include "avr/io.h"
#include "avr/interrupt.h"

//  
#include "cpusetup.inc"						// cpu  ͷƮ  ƾ

// Լ 
void Master_Send(char num);					// Master  
int LrcCul(char buf[],int max_cnt);				// SLAE FRAME  LRC

void putchar1(char c);						// COM2 1Ʈ ۽

//  
int tx_cnt = 0;							//  ī

// ===============================  α׷ ==============================
// [μ]: void
// ---------------------------------------------------------------------------
int main(void)
{
char buf[10];
int crc;

	cpu_setup();						// cpuʱȭ
	PORTE &= ~0x40;						// Zigbee Reset
	timer0_base_cnt = 0;					// ð 500ms
	while(timer0_base_cnt < 50);
	PORTE |= 0x40;						// Zigbee NON Reset
	timer0_base_cnt = 0;					// ð 1S
	while(timer0_base_cnt < 100);
	while(1){
		if(com2_rx_eflg){				// SLAVE  ó
			if(com2_rx_data[1] == SLAVE_NUM){	// ڱ  ȣ ˻ 
				crc = LrcCul(com2_rx_data,com2_rx_udi-3) & 0xff;// üũ 
				sprintf(buf,"%02X",crc);
				if(buf[0] == com2_rx_data[com2_rx_udi-3] && buf[1] == com2_rx_data[com2_rx_udi-2]){// LRC OK?
					Master_Send(SLAVE_NUM);	// Master  
					tx_cnt++;		//  ī 
					if(tx_cnt >= 9999) tx_cnt = 0;// 0 -> 9999 -> 0
				}
			}
			com2_rx_eflg = 0;
		}
	}
	return 0;
}

// ========================== Master   ===========================
// [μ]: char num
// Item1 :  SLAVE ȣ('1'-'2')
// ---------------------------------------------------------------------------
void Master_Send(char num)
{
char buf[10];
char com_tx_buf[50];
int i = 0,j,crc = 0;

	com_tx_buf[i++] = STX;					// STX 
	com_tx_buf[i++] = num;					// NUM 
	com_tx_buf[i++] = 'R';					// COMMAND 
	
	sprintf(buf,"%04d",tx_cnt);				// ī  4byte int
	com_tx_buf[i++] = buf[0];
	com_tx_buf[i++] = buf[1];
	com_tx_buf[i++] = buf[2];
	com_tx_buf[i++] = buf[3];
	
	for(j = 0; j < i; j++) crc ^= com_tx_buf[j];		// LRC 
	sprintf(buf,"%02X",crc&0xff);
	com_tx_buf[i++] = buf[0];				// LRC High
	com_tx_buf[i++] = buf[1];    				// LRC Low
	com_tx_buf[i++] = ETX;       				// ETX 
	com_tx_buf[i] = 0;       				// NULL 

	for(j = 0; j < i; j++) putchar1(com_tx_buf[j]);		//  ۽(COM2)

//	printf("send : %s\n",com_tx_buf);			// PC ۽  (ÿ)
}

// =========================== LRC  ==========================
// [μ] char buf[],int max_cnt
// Item1:  ڷ 
// Item2: ڷ 
// [] 
// ----------------------------------------------------------------
int LrcCul(char buf[],int max_cnt)
{
int i,accum = 0;

	for(i = 0; i < max_cnt; i++) accum ^= buf[i];		// XOR 
	return(accum & 0xff);
}

// ============================ COM2 1Ʈ ۽ ===========================
// [μ] char c					     
// Item1  ۽ 
// ----------------------------------------------------------------------------
void putchar1(char c)
{
	while((UCSR1A & DATA_REGISTER_EMPTY)==0);		// ۽Źۺ 
	UDR1 = c;
}
