// =========================== MEGA128 ZigBee Masterα׷ =================
//  CPU : ATmega128-16M
//     ¥ : 2006-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : CodeVisionAVR
//      : Master/SLAVE1/SLAVE2  
//            COM1-RS232(PC)    : 19200,N,8,1
//            COM2-RS485(XBee)  : 9600,N,8,1
//
// PortE.6(OUT) : RST\(L:,H:Reset)
// PortE.7(OUT) : XBee Sleep(0:NON,1:SLEEP) ::    .
// ----------------------------------------------------------------------------
//  
#define	STX	0x02						// COM  ڵ
#define	ETX	0x03						// COM    ڵ

// ⺻ 
#include <mega128.h>						// CPU  

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <float.h>
#include <math.h>

//  
#include "cpusetup.inc"						// cpu  ͷƮ  ƾ
// ============================= CPUʱȭ ͷƮ =========================
//      : CPU  ϰ ͷƮ  ƾ .
// ----------------------------------------------------------------------------
//   
#define RXB8 1
#define TXB8 0
#define UPE 2
#define OVR 3
#define FE 4
#define UDRE 5
#define RXC 7

#define FRAMING_ERROR (1<<FE)
#define PARITY_ERROR (1<<UPE)
#define DATA_OVERRUN (1<<OVR)
#define DATA_REGISTER_EMPTY (1<<UDRE)
#define RX_COMPLETE (1<<RXC)

// Լ 

//  
char com1_rx_data,com1_rx_eflg = 0;				// COM1   ͷƮ  /÷
char com2_rx_data[50],com2_rx_eflg = 0;				// COM2   ͷƮ  /÷
int com2_rx_usi = 0,com2_rx_udi = 0;				// COM2   

int timer0_base_cnt = 0;					// Ÿ̸0 ͷƮ  ī
int timer0_tx_cnt = 0;						// Ÿ̸0 ſ ī

// ===================================== CPUʱȭ ============================
// [μ] void
// ----------------------------------------------------------------------------
void cpu_setup(void)
{

// PortA 
	PORTA=0x00;						// Ʈ  reg
	DDRA=0x00;						// Ʈ  reg(0Է,1)
// PortB 
	PORTB=0x00;						// Ʈ  reg
	DDRB=0x00;						// Ʈ  reg(0Է,1)

// PortC 
	PORTC=0x00;						// Ʈ  reg
	DDRC=0x00;                                              // Ʈ  reg(0Է,1)

// PortD 
	PORTD=0x00;						// Ʈ  reg
	DDRD=0x00;                                              // Ʈ  reg(0Է,1)

// PortE 
// PORTE.6(OUT) : RST\(L:,H:Reset)
// PORTE.7(OUT) : Sleep( L)
	PORTE=0x40;						// Ʈ  reg
	DDRE=0xc0;                                              // Ʈ  reg(0Է,1)

// PortF 
	PORTF=0x00;						// Ʈ  reg
	DDRF=0x00;                                              // Ʈ  reg(0Է,1)
// PortG 
	PORTG=0x00;						// Ʈ  reg
	DDRG=0x00;                                              // Ʈ  reg(0Է,1)

// Timer/Counter0 
	ASSR=0x00;
	TCCR0 = 0x07;						// system clock,16,000,000 / 1024 = 15.625Khz
	TCNT0 = 99;						// 255-156 = 99
	OCR0=0x00;

// Timer/Counter1 
	TCCR1A=0x00;
	TCCR1B=0x00;
	TCNT1H=0x00;
	TCNT1L=0x00;
	OCR1AH=0x00;
	OCR1AL=0x00;
	OCR1BH=0x00;
	OCR1BL=0x00;
	OCR1CH=0x00;
	OCR1CL=0x00;

// Timer/Counter2 
	TCCR2=0x00;
	TCNT2=0x00;
	OCR2=0x00;

// Timer/Counter3 
	TCCR3A=0x00;
	TCCR3B=0x00;
	TCNT3H=0x00;
	TCNT3L=0x00;
	OCR3AH=0x00;
	OCR3AL=0x00;
	OCR3BH=0x00;
	OCR3BL=0x00;
	OCR3CH=0x00;
	OCR3CL=0x00;

// External Interrupt(s) 
// INT0: Off
// INT1: Off
// INT2: Off
// INT3: Off
// INT4: Off
// INT5: Off
// INT6: Off
// INT7: Off
	EICRA=0x00;
	EICRB=0x00;
	EIMSK=0x00;

// Timer(s)/Counter(s) Interrupt(s) 
	TIMSK |= 0x01;						// TIMER0 ͷƮ 㰡
	ETIMSK=0x00;

//  ʱȭ(COM1)
// 19200Bps, 8Data, 1 Stop, No Parity
	UCSR0A=0x00;
	UCSR0B=0x98;
	UCSR0C=0x06;
	UBRR0H=0x00;
	UBRR0L=0x33;

//  ʱȭ(COM2)
// 9600Bps, 8Data, 1 Stop, No Parity
	UCSR1A=0x00;
	UCSR1B=0x98;
	UCSR1C=0x06;
	UBRR1H=0x00;
	UBRR1L=0x67;

// External SRAM page configuration:
//              -              / 0000h - FFFFh
// Lower page wait state(s): None
// Upper page wait state(s): None
//	MCUCR=0x80;
//	XMCRA=0x00;

// Analog Comparator 
	ACSR=0x80;
	SFIOR=0x00;

// Global enable interrupts
#asm("sei")
}
// =============================== COM1 ͷƮ ===========================
// [μ] void
// ----------------------------------------------------------------------------
#pragma savereg-
interrupt [USART0_RXC] void uart0_rx_isr(void)
{
char status,data;
#asm
	push r26
	push r27
	push r30
	push r31
	in   r26,sreg
	push r26
#endasm

	status=UCSR0A;
	data=UDR0;
	if((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0){
		com1_rx_data = data;
		com1_rx_eflg = 1;
	}

#asm
	pop  r26
	out  sreg,r26
	pop  r31
	pop  r30
	pop  r27
	pop  r26
#endasm
}
#pragma savereg+

// ============================== COM2  ͷƮ ===========================
// [μ] void
// ----------------------------------------------------------------------------
#pragma savereg-
interrupt [USART1_RXC] void uart1_rx_isr(void)
{
char status,data;
#asm
	push r26
	push r27
	push r30
	push r31
	in   r26,sreg
	push r26
#endasm

	status=UCSR1A;
	data=UDR1;
	if((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0){
		if(com2_rx_eflg == 0){				//    ó ƴҶ
			if(data == STX){			//  ڵ ã
				com2_rx_usi = 0;		//   Ŭ
				com2_rx_data[com2_rx_usi++] = data;// STX 
			}
			else if(data == ETX){			//  ڵ ã
				com2_rx_data[com2_rx_usi++] = data;// ETX 
				com2_rx_data[com2_rx_usi] = 0;	// NULL  
				com2_rx_udi = com2_rx_usi;	//   ( ó )
				com2_rx_eflg = 1;		//  Ϸ ÷ ON( ó )
				com2_rx_usi = 0;		//   Ŭ
			}
			else{
				com2_rx_data[com2_rx_usi++] = data;//  
				if(com2_rx_usi >= 45) com2_rx_usi = 0;//  ʰ ˻
			}
		}
	}

#asm
	pop  r26
	out  sreg,r26
	pop  r31
	pop  r30
	pop  r27
	pop  r26
#endasm
}
#pragma savereg+

// ========================== TIMER0 overflow ͷƮ ========================
// [μ] void
// [] 16,000,000 / 1024 / 156 =  1 / 100.1602564 = 9.9984ms
// ----------------------------------------------------------------------------
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
	TCNT0 = 99;						// 255-156 = 100
	timer0_base_cnt++;					// Ÿ̸0 ⺻   ī 10ms
	timer0_tx_cnt++;					// Ÿ̸0 ſ ī 10ms
}

// Լ 
void Slave_Request(char num);					// SLAVEn  䱸
int LrcCul(char buf[],int max_cnt);				// SLAE FRAME  LRC

void putchar1(char c);						// COM2 1Ʈ ۽

//  

// ===============================  α׷ ==============================
// [μ]: void
// ---------------------------------------------------------------------------
int main(void)
{
char buf[10];
char snum = '1';
int crc;

	cpu_setup();						// cpuʱȭ
	PORTE &= ~0x40;						// Zigbee Reset
	timer0_base_cnt = 0;					// ð 500ms
	while(timer0_base_cnt < 50);
	PORTE |= 0x40;						// Zigbee NON Reset
	timer0_base_cnt = 0;					// ð 1S
	while(timer0_base_cnt < 100);

	timer0_tx_cnt = 0;					// ۽ Ÿ̸ ʱȭ

	while(1){
// XBee,XBee-PRO : 200ms
// XBee2 : ִ 3s
		if(timer0_tx_cnt >= 20){			//  200ms SLAVE  䱸(20*10ms)
			Slave_Request(snum);			//  䱸
			snum++;					// SZLAVE ȣ (1-2)
			if(snum >= '3') snum = '1';
			timer0_tx_cnt = 0;
		}
		if(com2_rx_eflg){				// SLAVE  ó
			crc = LrcCul(com2_rx_data,com2_rx_udi-3) & 0xff;// üũ 
			sprintf(buf,"%02X",crc);
			if(buf[0] == com2_rx_data[com2_rx_udi-3] && buf[1] == com2_rx_data[com2_rx_udi-2]){// LRC OK?
				printf("  :: RECV : %s",com2_rx_data);// PC   
			}
			com2_rx_eflg = 0;
		}
	}
	return 0;
}

// ========================== SLAVEn  䱸 ===========================
// [μ]: char num
// Item1 :  SLAVE ȣ('1'-'2')
// ---------------------------------------------------------------------------
void Slave_Request(char num)
{
char buf[10];
char com_tx_buf[50];
int i = 0,j,crc = 0;

	com_tx_buf[i++] = STX;					// STX
	com_tx_buf[i++] = num;					// NUM
	com_tx_buf[i++] = 'R';					// COMMAND

	for(j = 0; j < i; j++) crc ^= com_tx_buf[j];		// LRC 
	sprintf(buf,"%02X",crc&0xff);
	com_tx_buf[i++] = buf[0];				// LRC High
	com_tx_buf[i++] = buf[1];    				// LRC Low
	com_tx_buf[i++] = ETX;       				// ETX
	com_tx_buf[i] = 0;       				// NULL

	for(j = 0; j < i; j++) putchar1(com_tx_buf[j]);		//  ۽(COM2)

	printf("\r\nsend : %s",com_tx_buf);			// PC ۽  
}

// =========================== LRC  ==========================
// [μ] char buf[],int max_cnt
// Item1:  ڷ 
// Item2: ڷ 
// [] 
// ----------------------------------------------------------------
int LrcCul(char buf[],int max_cnt)
{
int i,accum = 0;

	for(i = 0; i < max_cnt;i++) accum ^= buf[i];		// XOR 
	return(accum & 0xff);
}

// ============================ COM2 1Ʈ ۽ ===========================
// [μ] char c
// Item1  ۽ 
// ----------------------------------------------------------------------------
void putchar1(char c)
{
	while((UCSR1A & DATA_REGISTER_EMPTY)==0);
	UDR1 = c;
}
