// =========================== MEGA128 ZigBee Slave1 α׷ =================
//  CPU : ATmega128-16M
//     ¥ : 2006-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : CodeVisionAVR
//      : Master/SLAVE1/SLAVE2  
//            COM1-RS232(PC)    : 19200,N,8,1
//            COM2-RS485(XBee)  : 9600,N,8,1
//
// PortE.6(OUT) : RST\(L:,H:Reset)
// PortE.7(OUT) : XBee Sleep(0:NON,1:SLEEP) ::    .
// ----------------------------------------------------------------------------
// ⺻ 

// ⺻ 
// CodeVisionAVR C Compiler
// (C) 1998-2004 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATmega128


#pragma used+
sfrb PINF=0;
sfrb PINE=1;
sfrb DDRE=2;
sfrb PORTE=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      // 16 bit access
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRR0L=9;
sfrb UCSR0B=0xa;
sfrb UCSR0A=0xb;
sfrb UDR0=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   // 16 bit access
sfrb SFIOR=0x20;
sfrb WDTCR=0x21;
sfrb OCDR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrw ICR1=0x26;   // 16 bit access
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  // 16 bit access
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  // 16 bit access
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  // 16 bit access
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb ASSR=0x30;
sfrb OCR0=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TIFR=0x36;
sfrb TIMSK=0x37;
sfrb EIFR=0x38;
sfrb EIMSK=0x39;
sfrb EICRB=0x3a;
sfrb RAMPZ=0x3b;
sfrb XDIV=0x3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-


// Interrupt vectors definitions



// CodeVisionAVR C Compiler
// (C) 1998-2006 Pavel Haiduc, HP InfoTech S.R.L.

// Prototypes for standard I/O functions


// CodeVisionAVR C Compiler
// (C) 1998-2002 Pavel Haiduc, HP InfoTech S.R.L.

// Variable length argument list macros



typedef char *va_list;





#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);

char *gets(char *str,unsigned int len);

void printf(char flash *fmtstr,...);
void sprintf(char *str, char flash *fmtstr,...);
void snprintf(char *str, unsigned int size, char flash *fmtstr,...);
void vprintf (char flash * fmtstr, va_list argptr);
void vsprintf (char *str, char flash * fmtstr, va_list argptr);
void vsnprintf (char *str, unsigned int size, char flash * fmtstr, va_list argptr);
signed char scanf(char flash *fmtstr,...);
signed char sscanf(char *str, char flash *fmtstr,...);




                                   

            


#pragma used-

#pragma library stdio.lib


/* CodeVisionAVR C Compiler
   Prototypes for standard library functions

   (C) 1998-2003 Pavel Haiduc, HP InfoTech S.R.L.
*/




#pragma used+

int atoi(char *str);
long int atol(char *str);
float atof(char *str);
void itoa(int n,char *str);
void ltoa(long int n,char *str);
void ftoa(float n,unsigned char decimals,char *str);
void ftoe(float n,unsigned char decimals,char *str);
void srand(int seed);
int rand(void);
void *malloc(unsigned int size);
void *calloc(unsigned int num, unsigned int size);
void *realloc(void *ptr, unsigned int size); 
void free(void *ptr);

#pragma used-
#pragma library stdlib.lib


// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.

// Prototypes for character type functions


#pragma used+

unsigned char isalnum(char c);
unsigned char isalpha(char c);
unsigned char isascii(char c);
unsigned char iscntrl(char c);
unsigned char isdigit(char c);
unsigned char islower(char c);
unsigned char isprint(char c);
unsigned char ispunct(char c);
unsigned char isspace(char c);
unsigned char isupper(char c);
unsigned char isxdigit(char c);
unsigned char toint(char c);
char tolower(char c);
char toupper(char c);

#pragma used-


/* CodeVisionAVR C Compiler
   (C) 1998-2001 Pavel Haiduc, HP InfoTech S.R.L. */






/*
CodeVisionAVR C Compiler
Prototypes for mathematical functions

Portions (C) 1998-2001 Pavel Haiduc, HP InfoTech S.R.L.
Portions (C) 2000-2001 Yuri G. Salov
*/



#pragma used+

unsigned char cabs(signed char x);
unsigned int abs(int x);
unsigned long labs(long x);
float fabs(float x);
signed char cmax(signed char a,signed char b);
int max(int a,int b);
long lmax(long a,long b);
float fmax(float a,float b);
signed char cmin(signed char a,signed char b);
int min(int a,int b);
long lmin(long a,long b);
float fmin(float a,float b);
signed char csign(signed char x);
signed char sign(int x);
signed char lsign(long x);
signed char fsign(float x);
unsigned char isqrt(unsigned int x);
unsigned int lsqrt(unsigned long x);
float sqrt(float x);
float floor(float x);
float ceil(float x);
float fmod(float x,float y);
float modf(float x,float *ipart);
float ldexp(float x,int expon);
float frexp(float x,int *expon);
float exp(float x);
float log(float x);
float log10(float x);
float pow(float x,float y);
float sin(float x);
float cos(float x);
float tan(float x);
float sinh(float x);
float cosh(float x);
float tanh(float x);
float asin(float x);
float acos(float x);
float atan(float x);
float atan2(float y,float x);

#pragma used-
#pragma library math.lib



//  
// ============================= CPUʱȭ ͷƮ =========================
//      : CPU  ϰ ͷƮ  ƾ .
// ----------------------------------------------------------------------------
//   


// Լ 

//  
char com1_rx_data,com1_rx_eflg = 0;				// COM1   ͷƮ  /÷
char com2_rx_data[50],com2_rx_eflg = 0;				// COM2   ͷƮ  /÷
int com2_rx_usi = 0,com2_rx_udi = 0;				// COM2   

int timer0_base_cnt = 0;					// Ÿ̸0 ͷƮ  ī

// ===================================== CPUʱȭ ============================
// [μ] void
// ----------------------------------------------------------------------------
void cpu_setup(void)
{

// PortA 
	PORTA=0x00;						// Ʈ  reg
	DDRA=0x00;						// Ʈ  reg(0Է,1)
// PortB 
	PORTB=0x00;						// Ʈ  reg
	DDRB=0x00;						// Ʈ  reg(0Է,1)

// PortC 
	PORTC=0x00;						// Ʈ  reg             
	DDRC=0x00;                                              // Ʈ  reg(0Է,1)

// PortD 
	PORTD=0x00;						// Ʈ  reg             
	DDRD=0x00;                                              // Ʈ  reg(0Է,1)

// PortE 
// PORTE.6(OUT) : RST\(L:,H:Reset)
// PORTE.7(OUT) : Sleep( L)
	PORTE=0x40;						// Ʈ  reg             
	DDRE=0xc0;                                              // Ʈ  reg(0Է,1)
	
// PortF 
	(*(unsigned char *) 0x62)=0x00;						// Ʈ  reg             
	(*(unsigned char *) 0x61)=0x00;                                              // Ʈ  reg(0Է,1)
// PortG 
	(*(unsigned char *) 0x65)=0x00;						// Ʈ  reg             
	(*(unsigned char *) 0x64)=0x00;                                              // Ʈ  reg(0Է,1)

// Timer/Counter0 
	ASSR=0x00;
	TCCR0 = 0x07;						// system clock,16,000,000 / 1024 = 15.625Khz
	TCNT0 = 99;						// 255-156 = 99	
	OCR0=0x00;

// Timer/Counter1 
	TCCR1A=0x00;
	TCCR1B=0x00;
	TCNT1H=0x00;
	TCNT1L=0x00;
	OCR1AH=0x00;
	OCR1AL=0x00;
	OCR1BH=0x00;
	OCR1BL=0x00;
	(*(unsigned char *) 0x79)=0x00;
	(*(unsigned char *) 0x78)=0x00;

// Timer/Counter2 
	TCCR2=0x00;
	TCNT2=0x00;
	OCR2=0x00;

// Timer/Counter3 
	(*(unsigned char *) 0x8b)=0x00;
	(*(unsigned char *) 0x8a)=0x00;
	(*(unsigned char *) 0x89)=0x00;
	(*(unsigned char *) 0x88)=0x00;
	(*(unsigned char *) 0x87)=0x00;
	(*(unsigned char *) 0x86)=0x00;
	(*(unsigned char *) 0x85)=0x00;
	(*(unsigned char *) 0x84)=0x00;
	(*(unsigned char *) 0x83)=0x00;
	(*(unsigned char *) 0x82)=0x00;

// External Interrupt(s) 
// INT0: Off
// INT1: Off
// INT2: Off
// INT3: Off
// INT4: Off
// INT5: Off
// INT6: Off
// INT7: Off
	(*(unsigned char *) 0x6a)=0x00;
	EICRB=0x00;
	EIMSK=0x00;

// Timer(s)/Counter(s) Interrupt(s) 
	TIMSK |= 0x01;						// TIMER0 ͷƮ 㰡
	(*(unsigned char *) 0x7d)=0x00;

//  ʱȭ(COM1)
// 19200Bps, 8Data, 1 Stop, No Parity
	UCSR0A=0x00;
	UCSR0B=0x98;
	(*(unsigned char *) 0x95)=0x06;
	(*(unsigned char *) 0x90)=0x00;
	UBRR0L=0x33;

//  ʱȭ(COM2)
// 9600Bps, 8Data, 1 Stop, No Parity
	(*(unsigned char *) 0x9b)=0x00;
	(*(unsigned char *) 0x9a)=0x98;
	(*(unsigned char *) 0x9d)=0x06;
	(*(unsigned char *) 0x98)=0x00;
	(*(unsigned char *) 0x99)=0x67;

// External SRAM page configuration:
//              -              / 0000h - FFFFh
// Lower page wait state(s): None
// Upper page wait state(s): None
//	MCUCR=0x80;
//	XMCRA=0x00;

// Analog Comparator 
	ACSR=0x80;
	SFIOR=0x00;

// Global enable interrupts
#asm("sei")
}
// =============================== COM1 ͷƮ ===========================
// [μ] void
// ----------------------------------------------------------------------------
#pragma savereg-
interrupt [19] void uart0_rx_isr(void)
{
char status,data;
#asm
	push r26
	push r27
	push r30
	push r31
	in   r26,sreg
	push r26
#endasm

	status=UCSR0A;
	data=UDR0;
	if((status & ((1<<4) | (1<<2) | (1<<3)))==0){
		com1_rx_data = data;
		com1_rx_eflg = 1;
	}

#asm
	pop  r26
	out  sreg,r26
	pop  r31
	pop  r30
	pop  r27
	pop  r26
#endasm
}
#pragma savereg+

// ============================== COM2  ͷƮ ===========================
// [μ] void
// ----------------------------------------------------------------------------
#pragma savereg-
interrupt [31] void uart1_rx_isr(void)
{
char status,data;
#asm
	push r26
	push r27
	push r30
	push r31
	in   r26,sreg
	push r26
#endasm

	status=(*(unsigned char *) 0x9b);
	data=(*(unsigned char *) 0x9c);
	if((status & ((1<<4) | (1<<2) | (1<<3)))==0){
		if(com2_rx_eflg == 0){				//    ó ƴҶ
			if(data == 0x02					){			//  ڵ ã
				com2_rx_usi = 0;		//   Ŭ
				com2_rx_data[com2_rx_usi++] = data;// STX 
			}
			else if(data == 0x03					){			//  ڵ ã
				com2_rx_data[com2_rx_usi++] = data;// ETX 
				com2_rx_data[com2_rx_usi] = 0;	// NULL  
				com2_rx_udi = com2_rx_usi;	//   ( ó )
				com2_rx_eflg = 1;		//  Ϸ ÷ ON( ó )
				com2_rx_usi = 0;		//   Ŭ
			}
			else{
				com2_rx_data[com2_rx_usi++] = data;//  
				if(com2_rx_usi >= 45) com2_rx_usi = 0;//  ʰ ˻			
			}
		}
	}

#asm
	pop  r26
	out  sreg,r26
	pop  r31
	pop  r30
	pop  r27
	pop  r26
#endasm
}
#pragma savereg+

// ========================== TIMER0 overflow ͷƮ ========================
// [μ] void
// [] 16,000,000 / 1024 / 156 =  1 / 100.1602564 = 9.9984ms
// ----------------------------------------------------------------------------
interrupt [17] void timer0_ovf_isr(void)
{
	TCNT0 = 99;						// 255-156 = 100
	timer0_base_cnt++;					// Ÿ̸0 ⺻   ī 10ms
}

// Լ 
void Master_Send(char num);					// Master  
int LrcCul(char buf[],int max_cnt);				// SLAE FRAME  LRC

void putchar1(char c);						// COM2 1Ʈ ۽

//  
int tx_cnt = 0;							//  ī

// ===============================  α׷ ==============================
// [μ]: void
// ---------------------------------------------------------------------------
int main(void)
{
char buf[10];
int crc;

	cpu_setup();						// cpuʱȭ
	PORTE &= ~0x40;						// Zigbee Reset
	timer0_base_cnt = 0;					// ð 500ms
	while(timer0_base_cnt < 50);
	PORTE |= 0x40;						// Zigbee NON Reset
	timer0_base_cnt = 0;					// ð 1S
	while(timer0_base_cnt < 100);
	while(1){
		if(com2_rx_eflg){				// SLAVE  ó
			if(com2_rx_data[1] == '1'					){	// ڱ  ȣ ˻ 
				crc = LrcCul(com2_rx_data,com2_rx_udi-3) & 0xff;// üũ 
				sprintf(buf,"%02X",crc);
				if(buf[0] == com2_rx_data[com2_rx_udi-3] && buf[1] == com2_rx_data[com2_rx_udi-2]){// LRC OK?
					Master_Send('1'					);	// Master  
					tx_cnt++;		//  ī 
					if(tx_cnt >= 9999) tx_cnt = 0;// 0 -> 9999 -> 0
				}
			}
			com2_rx_eflg = 0;
		}
	}
	return 0;
}

// ========================== Master   ===========================
// [μ]: char num
// Item1 :  SLAVE ȣ('1'-'2')
// ---------------------------------------------------------------------------
void Master_Send(char num)
{
char buf[10];
char com_tx_buf[50];
int i = 0,j,crc = 0;

	com_tx_buf[i++] = 0x02					;					// STX 
	com_tx_buf[i++] = num;					// NUM 
	com_tx_buf[i++] = 'R';					// COMMAND 
	
	sprintf(buf,"%04d",tx_cnt);				// ī  4byte int
	com_tx_buf[i++] = buf[0];
	com_tx_buf[i++] = buf[1];
	com_tx_buf[i++] = buf[2];
	com_tx_buf[i++] = buf[3];
	
	for(j = 0; j < i; j++) crc ^= com_tx_buf[j];		// LRC 
	sprintf(buf,"%02X",crc&0xff);
	com_tx_buf[i++] = buf[0];				// LRC High
	com_tx_buf[i++] = buf[1];    				// LRC Low
	com_tx_buf[i++] = 0x03					;       				// ETX 
	com_tx_buf[i] = 0;       				// NULL 

	for(j = 0; j < i; j++) putchar1(com_tx_buf[j]);		//  ۽(COM2)

	printf("send : %s\r\n",com_tx_buf);			// PC ۽  (ÿ)
}

// =========================== LRC  ==========================
// [μ] char buf[],int max_cnt
// Item1:  ڷ 
// Item2: ڷ 
// [] 
// ----------------------------------------------------------------
int LrcCul(char buf[],int max_cnt)
{
int i,accum = 0;

	for(i = 0; i < max_cnt; i++) accum ^= buf[i];		// XOR 
	return(accum & 0xff);
}

// ============================ COM2 1Ʈ ۽ ===========================
// [μ] char c					     
// Item1  ۽ 
// ----------------------------------------------------------------------------
void putchar1(char c)
{
	while(((*(unsigned char *) 0x9b) & (1<<5))==0);
	(*(unsigned char *) 0x9c) = c;
}
