
;CodeVisionAVR C Compiler V1.25.3 Professional
;(C) Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega128
;Program type           : Application
;Clock frequency        : 16.000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 1024 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: No
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega128
	#pragma AVRPART MEMORY PROG_FLASH 131072
	#pragma AVRPART MEMORY EEPROM 4096
	#pragma AVRPART MEMORY INT_SRAM SIZE 4096
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x100

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU RAMPZ=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU XMCRA=0x6D
	.EQU XMCRB=0x6C

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_adc_noise_red=0x08
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "slave.vec"
	.INCLUDE "slave.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  MCUCR,R31
	OUT  MCUCR,R30
	STS  XMCRB,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x1000)
	LDI  R25,HIGH(0x1000)
	LDI  R26,LOW(0x100)
	LDI  R27,HIGH(0x100)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

	OUT  RAMPZ,R24

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x10FF)
	OUT  SPL,R30
	LDI  R30,HIGH(0x10FF)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x500)
	LDI  R29,HIGH(0x500)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x500
;       1 // =========================== MEGA128 ZigBee Slave2 α׷ =================
;       2 //  CPU : ATmega128-16M
;       3 //     ¥ : 2006-
;       4 //      : Ver1.0
;       5 //    : www.cpuplaza.com
;       6 // Ϸ : CodeVisionAVR
;       7 //      : Master/SLAVE1/SLAVE2  
;       8 //            COM1-RS232(PC)    : 19200,N,8,1
;       9 //            COM2-RS485(XBee)  : 9600,N,8,1
;      10 //
;      11 // PortE.6(OUT) : RST\(L:,H:Reset)
;      12 // PortE.7(OUT) : XBee Sleep(0:NON,1:SLEEP) ::    .
;      13 // ----------------------------------------------------------------------------
;      14 // ⺻ 
;      15 #define	STX		0x02					// COM  ڵ
;      16 #define	ETX		0x03					// COM    ڵ
;      17 #define	SLAVE_NUM	'2'					// SLAVE ȣ('1' -  '2')
;      18 
;      19 // ⺻ 
;      20 #include <mega128.h>						// CPU  
;      21 
;      22 #include <stdio.h>
;      23 #include <stdlib.h>
;      24 #include <ctype.h>
;      25 #include <float.h>
;      26 #include <math.h>
;      27 
;      28 //  
;      29 #include "cpusetup.inc"						// cpu  ͷƮ  ƾ
;      30 // ============================= CPUʱȭ ͷƮ =========================
;      31 //      : CPU  ϰ ͷƮ  ƾ .
;      32 // ----------------------------------------------------------------------------
;      33 //   
;      34 #define RXB8 1
;      35 #define TXB8 0
;      36 #define UPE 2
;      37 #define OVR 3
;      38 #define FE 4
;      39 #define UDRE 5
;      40 #define RXC 7
;      41 
;      42 #define FRAMING_ERROR (1<<FE)
;      43 #define PARITY_ERROR (1<<UPE)
;      44 #define DATA_OVERRUN (1<<OVR)
;      45 #define DATA_REGISTER_EMPTY (1<<UDRE)
;      46 #define RX_COMPLETE (1<<RXC)
;      47 
;      48 // Լ 
;      49 
;      50 //  
;      51 char com1_rx_data,com1_rx_eflg = 0;				// COM1   ͷƮ  /÷
;      52 char com2_rx_data[50],com2_rx_eflg = 0;				// COM2   ͷƮ  /÷
_com2_rx_data:
	.BYTE 0x32
;      53 int com2_rx_usi = 0,com2_rx_udi = 0;				// COM2   
;      54 
;      55 int timer0_base_cnt = 0;					// Ÿ̸0 ͷƮ  ī
;      56 
;      57 // ===================================== CPUʱȭ ============================
;      58 // [μ] void
;      59 // ----------------------------------------------------------------------------
;      60 void cpu_setup(void)
;      61 {

	.CSEG
_cpu_setup:
;      62 
;      63 // PortA 
;      64 	PORTA=0x00;						// Ʈ  reg
	LDI  R30,LOW(0)
	OUT  0x1B,R30
;      65 	DDRA=0x00;						// Ʈ  reg(0Է,1)
	OUT  0x1A,R30
;      66 // PortB 
;      67 	PORTB=0x00;						// Ʈ  reg
	OUT  0x18,R30
;      68 	DDRB=0x00;						// Ʈ  reg(0Է,1)
	OUT  0x17,R30
;      69 
;      70 // PortC 
;      71 	PORTC=0x00;						// Ʈ  reg
	OUT  0x15,R30
;      72 	DDRC=0x00;                                              // Ʈ  reg(0Է,1)
	OUT  0x14,R30
;      73 
;      74 // PortD 
;      75 	PORTD=0x00;						// Ʈ  reg
	OUT  0x12,R30
;      76 	DDRD=0x00;                                              // Ʈ  reg(0Է,1)
	OUT  0x11,R30
;      77 
;      78 // PortE 
;      79 // PORTE.6(OUT) : RST\(L:,H:Reset)
;      80 // PORTE.7(OUT) : Sleep( L)
;      81 	PORTE=0x40;						// Ʈ  reg
	LDI  R30,LOW(64)
	OUT  0x3,R30
;      82 	DDRE=0xc0;                                              // Ʈ  reg(0Է,1)
	LDI  R30,LOW(192)
	OUT  0x2,R30
;      83 
;      84 // PortF 
;      85 	PORTF=0x00;						// Ʈ  reg
	LDI  R30,LOW(0)
	STS  98,R30
;      86 	DDRF=0x00;                                              // Ʈ  reg(0Է,1)
	STS  97,R30
;      87 // PortG 
;      88 	PORTG=0x00;						// Ʈ  reg
	STS  101,R30
;      89 	DDRG=0x00;                                              // Ʈ  reg(0Է,1)
	STS  100,R30
;      90 
;      91 // Timer/Counter0 
;      92 	ASSR=0x00;
	OUT  0x30,R30
;      93 	TCCR0 = 0x07;						// system clock,16,000,000 / 1024 = 15.625Khz
	LDI  R30,LOW(7)
	OUT  0x33,R30
;      94 	TCNT0 = 99;						// 255-156 = 99
	LDI  R30,LOW(99)
	OUT  0x32,R30
;      95 	OCR0=0x00;
	LDI  R30,LOW(0)
	OUT  0x31,R30
;      96 
;      97 // Timer/Counter1 
;      98 	TCCR1A=0x00;
	OUT  0x2F,R30
;      99 	TCCR1B=0x00;
	OUT  0x2E,R30
;     100 	TCNT1H=0x00;
	OUT  0x2D,R30
;     101 	TCNT1L=0x00;
	OUT  0x2C,R30
;     102 	OCR1AH=0x00;
	OUT  0x2B,R30
;     103 	OCR1AL=0x00;
	OUT  0x2A,R30
;     104 	OCR1BH=0x00;
	OUT  0x29,R30
;     105 	OCR1BL=0x00;
	OUT  0x28,R30
;     106 	OCR1CH=0x00;
	STS  121,R30
;     107 	OCR1CL=0x00;
	STS  120,R30
;     108 
;     109 // Timer/Counter2 
;     110 	TCCR2=0x00;
	OUT  0x25,R30
;     111 	TCNT2=0x00;
	OUT  0x24,R30
;     112 	OCR2=0x00;
	OUT  0x23,R30
;     113 
;     114 // Timer/Counter3 
;     115 	TCCR3A=0x00;
	STS  139,R30
;     116 	TCCR3B=0x00;
	STS  138,R30
;     117 	TCNT3H=0x00;
	STS  137,R30
;     118 	TCNT3L=0x00;
	STS  136,R30
;     119 	OCR3AH=0x00;
	STS  135,R30
;     120 	OCR3AL=0x00;
	STS  134,R30
;     121 	OCR3BH=0x00;
	STS  133,R30
;     122 	OCR3BL=0x00;
	STS  132,R30
;     123 	OCR3CH=0x00;
	STS  131,R30
;     124 	OCR3CL=0x00;
	STS  130,R30
;     125 
;     126 // External Interrupt(s) 
;     127 // INT0: Off
;     128 // INT1: Off
;     129 // INT2: Off
;     130 // INT3: Off
;     131 // INT4: Off
;     132 // INT5: Off
;     133 // INT6: Off
;     134 // INT7: Off
;     135 	EICRA=0x00;
	STS  106,R30
;     136 	EICRB=0x00;
	OUT  0x3A,R30
;     137 	EIMSK=0x00;
	OUT  0x39,R30
;     138 
;     139 // Timer(s)/Counter(s) Interrupt(s) 
;     140 	TIMSK |= 0x01;						// TIMER0 ͷƮ 㰡
	IN   R30,0x37
	ORI  R30,1
	OUT  0x37,R30
;     141 	ETIMSK=0x00;
	LDI  R30,LOW(0)
	STS  125,R30
;     142 
;     143 //  ʱȭ(COM1)
;     144 // 19200Bps, 8Data, 1 Stop, No Parity
;     145 	UCSR0A=0x00;
	OUT  0xB,R30
;     146 	UCSR0B=0x98;
	LDI  R30,LOW(152)
	OUT  0xA,R30
;     147 	UCSR0C=0x06;
	LDI  R30,LOW(6)
	STS  149,R30
;     148 	UBRR0H=0x00;
	LDI  R30,LOW(0)
	STS  144,R30
;     149 	UBRR0L=0x33;
	LDI  R30,LOW(51)
	OUT  0x9,R30
;     150 
;     151 //  ʱȭ(COM2)
;     152 // 9600Bps, 8Data, 1 Stop, No Parity
;     153 	UCSR1A=0x00;
	LDI  R30,LOW(0)
	STS  155,R30
;     154 	UCSR1B=0x98;
	LDI  R30,LOW(152)
	STS  154,R30
;     155 	UCSR1C=0x06;
	LDI  R30,LOW(6)
	STS  157,R30
;     156 	UBRR1H=0x00;
	LDI  R30,LOW(0)
	STS  152,R30
;     157 	UBRR1L=0x67;
	LDI  R30,LOW(103)
	STS  153,R30
;     158 
;     159 // External SRAM page configuration:
;     160 //              -              / 0000h - FFFFh
;     161 // Lower page wait state(s): None
;     162 // Upper page wait state(s): None
;     163 //	MCUCR=0x80;
;     164 //	XMCRA=0x00;
;     165 
;     166 // Analog Comparator 
;     167 	ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     168 	SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x20,R30
;     169 
;     170 // Global enable interrupts
;     171 #asm("sei")
	sei
;     172 }
	RET
;     173 // =============================== COM1 ͷƮ ===========================
;     174 // [μ] void
;     175 // ----------------------------------------------------------------------------
;     176 #pragma savereg-
;     177 interrupt [USART0_RXC] void uart0_rx_isr(void)
;     178 {
_uart0_rx_isr:
;     179 char status,data;
;     180 #asm
;     181 	push r26
	push r26
;     182 	push r27
	push r27
;     183 	push r30
	push r30
;     184 	push r31
	push r31
;     185 	in   r26,sreg
	in   r26,sreg
;     186 	push r26
	push r26
;     187 #endasm
;     188 
;     189 	status=UCSR0A;
	ST   -Y,R17
	ST   -Y,R16
;	status -> R17
;	data -> R16
	IN   R17,11
;     190 	data=UDR0;
	IN   R16,12
;     191 	if((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0){
	MOV  R30,R17
	ANDI R30,LOW(0x1C)
	BRNE _0x3
;     192 		com1_rx_data = data;
	MOV  R5,R16
;     193 		com1_rx_eflg = 1;
	LDI  R30,LOW(1)
	MOV  R4,R30
;     194 	}
;     195 
;     196 #asm
_0x3:
;     197 	pop  r26
	pop  r26
;     198 	out  sreg,r26
	out  sreg,r26
;     199 	pop  r31
	pop  r31
;     200 	pop  r30
	pop  r30
;     201 	pop  r27
	pop  r27
;     202 	pop  r26
	pop  r26
;     203 #endasm
;     204 }
	LD   R16,Y+
	LD   R17,Y+
	RETI
;     205 #pragma savereg+
;     206 
;     207 // ============================== COM2  ͷƮ ===========================
;     208 // [μ] void
;     209 // ----------------------------------------------------------------------------
;     210 #pragma savereg-
;     211 interrupt [USART1_RXC] void uart1_rx_isr(void)
;     212 {
_uart1_rx_isr:
;     213 char status,data;
;     214 #asm
;     215 	push r26
	push r26
;     216 	push r27
	push r27
;     217 	push r30
	push r30
;     218 	push r31
	push r31
;     219 	in   r26,sreg
	in   r26,sreg
;     220 	push r26
	push r26
;     221 #endasm
;     222 
;     223 	status=UCSR1A;
	ST   -Y,R17
	ST   -Y,R16
;	status -> R17
;	data -> R16
	LDS  R17,155
;     224 	data=UDR1;
	LDS  R16,156
;     225 	if((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0){
	MOV  R30,R17
	ANDI R30,LOW(0x1C)
	BRNE _0x4
;     226 		if(com2_rx_eflg == 0){				//    ó ƴҶ
	TST  R7
	BRNE _0x5
;     227 			if(data == STX){			//  ڵ ã
	CPI  R16,2
	BRNE _0x6
;     228 				com2_rx_usi = 0;		//   Ŭ
	CLR  R8
	CLR  R9
;     229 				com2_rx_data[com2_rx_usi++] = data;// STX 
	CALL SUBOPT_0x0
;     230 			}
;     231 			else if(data == ETX){			//  ڵ ã
	RJMP _0x7
_0x6:
	CPI  R16,3
	BRNE _0x8
;     232 				com2_rx_data[com2_rx_usi++] = data;// ETX 
	CALL SUBOPT_0x0
;     233 				com2_rx_data[com2_rx_usi] = 0;	// NULL  
	LDI  R26,LOW(_com2_rx_data)
	LDI  R27,HIGH(_com2_rx_data)
	ADD  R26,R8
	ADC  R27,R9
	LDI  R30,LOW(0)
	ST   X,R30
;     234 				com2_rx_udi = com2_rx_usi;	//   ( ó )
	MOVW R10,R8
;     235 				com2_rx_eflg = 1;		//  Ϸ ÷ ON( ó )
	LDI  R30,LOW(1)
	MOV  R7,R30
;     236 				com2_rx_usi = 0;		//   Ŭ
	RJMP _0x89
;     237 			}
;     238 			else{
_0x8:
;     239 				com2_rx_data[com2_rx_usi++] = data;//  
	CALL SUBOPT_0x0
;     240 				if(com2_rx_usi >= 45) com2_rx_usi = 0;//  ʰ ˻
	LDI  R30,LOW(45)
	LDI  R31,HIGH(45)
	CP   R8,R30
	CPC  R9,R31
	BRLT _0xA
_0x89:
	CLR  R8
	CLR  R9
;     241 			}
_0xA:
_0x7:
;     242 		}
;     243 	}
_0x5:
;     244 
;     245 #asm
_0x4:
;     246 	pop  r26
	pop  r26
;     247 	out  sreg,r26
	out  sreg,r26
;     248 	pop  r31
	pop  r31
;     249 	pop  r30
	pop  r30
;     250 	pop  r27
	pop  r27
;     251 	pop  r26
	pop  r26
;     252 #endasm
;     253 }
	LD   R16,Y+
	LD   R17,Y+
	RETI
;     254 #pragma savereg+
;     255 
;     256 // ========================== TIMER0 overflow ͷƮ ========================
;     257 // [μ] void
;     258 // [] 16,000,000 / 1024 / 156 =  1 / 100.1602564 = 9.9984ms
;     259 // ----------------------------------------------------------------------------
;     260 interrupt [TIM0_OVF] void timer0_ovf_isr(void)
;     261 {
_timer0_ovf_isr:
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;     262 	TCNT0 = 99;						// 255-156 = 100
	LDI  R30,LOW(99)
	OUT  0x32,R30
;     263 	timer0_base_cnt++;					// Ÿ̸0 ⺻   ī 10ms
	MOVW R30,R12
	ADIW R30,1
	MOVW R12,R30
;     264 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	RETI
;     265 
;     266 // Լ 
;     267 void Master_Send(char num);					// Master  
;     268 int LrcCul(char buf[],int max_cnt);				// SLAE FRAME  LRC
;     269 
;     270 void putchar1(char c);						// COM2 1Ʈ ۽
;     271 
;     272 //  
;     273 int tx_cnt = 0;							//  ī

	.DSEG
_tx_cnt:
	.BYTE 0x2
;     274 
;     275 // ===============================  α׷ ==============================
;     276 // [μ]: void
;     277 // ---------------------------------------------------------------------------
;     278 int main(void)
;     279 {

	.CSEG
_main:
;     280 char buf[10];
;     281 int crc;
;     282 
;     283 	cpu_setup();						// cpuʱȭ
	SBIW R28,10
;	buf -> Y+0
;	crc -> R16,R17
	CALL _cpu_setup
;     284 	PORTE &= ~0x40;						// Zigbee Reset
	CBI  0x3,6
;     285 	timer0_base_cnt = 0;					// ð 500ms
	CLR  R12
	CLR  R13
;     286 	while(timer0_base_cnt < 50);
_0xB:
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	CP   R12,R30
	CPC  R13,R31
	BRLT _0xB
;     287 	PORTE |= 0x40;						// Zigbee NON Reset
	SBI  0x3,6
;     288 	timer0_base_cnt = 0;					// ð 1S
	CLR  R12
	CLR  R13
;     289 	while(timer0_base_cnt < 100);
_0xE:
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	CP   R12,R30
	CPC  R13,R31
	BRLT _0xE
;     290 	while(1){
_0x11:
;     291 		if(com2_rx_eflg){				// SLAVE  ó
	TST  R7
	BRNE PC+3
	JMP _0x14
;     292 			if(com2_rx_data[1] == SLAVE_NUM){	// ڱ  ȣ ˻
	__GETB1MN _com2_rx_data,1
	CPI  R30,LOW(0x32)
	BREQ PC+3
	JMP _0x15
;     293 				crc = LrcCul(com2_rx_data,com2_rx_udi-3) & 0xff;// üũ 
	LDI  R30,LOW(_com2_rx_data)
	LDI  R31,HIGH(_com2_rx_data)
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R10
	SBIW R30,3
	ST   -Y,R31
	ST   -Y,R30
	RCALL _LrcCul
	ANDI R31,HIGH(0xFF)
	MOVW R16,R30
;     294 				sprintf(buf,"%02X",crc);
	MOVW R30,R28
	CALL SUBOPT_0x1
	MOVW R30,R16
	CALL SUBOPT_0x2
;     295 				if(buf[0] == com2_rx_data[com2_rx_udi-3] && buf[1] == com2_rx_data[com2_rx_udi-2]){// LRC OK?
	MOVW R30,R10
	SBIW R30,3
	SUBI R30,LOW(-_com2_rx_data)
	SBCI R31,HIGH(-_com2_rx_data)
	LD   R30,Z
	LD   R26,Y
	CP   R30,R26
	BRNE _0x17
	MOVW R30,R10
	SBIW R30,2
	SUBI R30,LOW(-_com2_rx_data)
	SBCI R31,HIGH(-_com2_rx_data)
	LD   R30,Z
	LDD  R26,Y+1
	CP   R30,R26
	BREQ _0x18
_0x17:
	RJMP _0x16
_0x18:
;     296 					Master_Send(SLAVE_NUM);	// Master  
	LDI  R30,LOW(50)
	ST   -Y,R30
	RCALL _Master_Send
;     297 					tx_cnt++;		//  ī 
	LDS  R30,_tx_cnt
	LDS  R31,_tx_cnt+1
	ADIW R30,1
	STS  _tx_cnt,R30
	STS  _tx_cnt+1,R31
;     298 					if(tx_cnt >= 9999) tx_cnt = 0;// 0 -> 9999 -> 0
	LDS  R26,_tx_cnt
	LDS  R27,_tx_cnt+1
	CPI  R26,LOW(0x270F)
	LDI  R30,HIGH(0x270F)
	CPC  R27,R30
	BRLT _0x19
	LDI  R30,0
	STS  _tx_cnt,R30
	STS  _tx_cnt+1,R30
;     299 				}
_0x19:
;     300 			}
_0x16:
;     301 			com2_rx_eflg = 0;
_0x15:
	CLR  R7
;     302 		}
;     303 	}
_0x14:
	RJMP _0x11
;     304 	return 0;
_0x1A:
	RJMP _0x1A
;     305 }
;     306 
;     307 // ========================== Master   ===========================
;     308 // [μ]: char num
;     309 // Item1 :  SLAVE ȣ('1'-'2')
;     310 // ---------------------------------------------------------------------------
;     311 void Master_Send(char num)
;     312 {
_Master_Send:
;     313 char buf[10];
;     314 char com_tx_buf[50];
;     315 int i = 0,j,crc = 0;
;     316 
;     317 	com_tx_buf[i++] = STX;					// STX
	SBIW R28,60
	CALL __SAVELOCR6
;	num -> Y+66
;	buf -> Y+56
;	com_tx_buf -> Y+6
;	i -> R16,R17
;	j -> R18,R19
;	crc -> R20,R21
	LDI  R16,0
	LDI  R17,0
	LDI  R20,0
	LDI  R21,0
	CALL SUBOPT_0x3
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(2)
	ST   X,R30
;     318 	com_tx_buf[i++] = num;					// NUM
	CALL SUBOPT_0x3
	ADD  R30,R26
	ADC  R31,R27
	__GETB2SX 66
	STD  Z+0,R26
;     319 	com_tx_buf[i++] = 'R';					// COMMAND
	CALL SUBOPT_0x3
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(82)
	ST   X,R30
;     320 
;     321 	sprintf(buf,"%04d",tx_cnt);				// ī  4byte int
	MOVW R30,R28
	ADIW R30,56
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0,5
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_tx_cnt
	LDS  R31,_tx_cnt+1
	CALL SUBOPT_0x2
;     322 	com_tx_buf[i++] = buf[0];
	CALL SUBOPT_0x3
	CALL SUBOPT_0x4
;     323 	com_tx_buf[i++] = buf[1];
	CALL SUBOPT_0x5
;     324 	com_tx_buf[i++] = buf[2];
	ADD  R30,R26
	ADC  R31,R27
	LDD  R26,Y+58
	STD  Z+0,R26
;     325 	com_tx_buf[i++] = buf[3];
	CALL SUBOPT_0x3
	ADD  R30,R26
	ADC  R31,R27
	LDD  R26,Y+59
	STD  Z+0,R26
;     326 
;     327 	for(j = 0; j < i; j++) crc ^= com_tx_buf[j];		// LRC 
	__GETWRN 18,19,0
_0x1C:
	__CPWRR 18,19,16,17
	BRGE _0x1D
	MOVW R26,R28
	ADIW R26,6
	ADD  R26,R18
	ADC  R27,R19
	LD   R30,X
	LDI  R31,0
	__EORWRR 20,21,30,31
;     328 	sprintf(buf,"%02X",crc&0xff);
	__ADDWRN 18,19,1
	RJMP _0x1C
_0x1D:
	MOVW R30,R28
	ADIW R30,56
	CALL SUBOPT_0x1
	MOVW R30,R20
	ANDI R31,HIGH(0xFF)
	CALL SUBOPT_0x2
;     329 	com_tx_buf[i++] = buf[0];				// LRC High
	CALL SUBOPT_0x3
	CALL SUBOPT_0x4
;     330 	com_tx_buf[i++] = buf[1];    				// LRC Low
	CALL SUBOPT_0x5
;     331 	com_tx_buf[i++] = ETX;       				// ETX
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(3)
	ST   X,R30
;     332 	com_tx_buf[i] = 0;       				// NULL
	MOVW R26,R28
	ADIW R26,6
	ADD  R26,R16
	ADC  R27,R17
	LDI  R30,LOW(0)
	ST   X,R30
;     333 
;     334 	for(j = 0; j < i; j++) putchar1(com_tx_buf[j]);		//  ۽(COM2)
	__GETWRN 18,19,0
_0x1F:
	__CPWRR 18,19,16,17
	BRGE _0x20
	MOVW R26,R28
	ADIW R26,6
	ADD  R26,R18
	ADC  R27,R19
	LD   R30,X
	ST   -Y,R30
	RCALL _putchar1
;     335 
;     336 	printf("send : %s\r\n",com_tx_buf);			// PC ۽  (ÿ)
	__ADDWRN 18,19,1
	RJMP _0x1F
_0x20:
	__POINTW1FN _0,10
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,8
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _printf
	ADIW R28,6
;     337 }
	CALL __LOADLOCR6
	ADIW R28,63
	ADIW R28,4
	RET
;     338 
;     339 // =========================== LRC  ==========================
;     340 // [μ] char buf[],int max_cnt
;     341 // Item1:  ڷ 
;     342 // Item2: ڷ 
;     343 // [] 
;     344 // ----------------------------------------------------------------
;     345 int LrcCul(char buf[],int max_cnt)
;     346 {
_LrcCul:
;     347 int i,accum = 0;
;     348 
;     349 	for(i = 0; i < max_cnt; i++) accum ^= buf[i];		// XOR 
	CALL __SAVELOCR4
;	*buf -> Y+6
;	max_cnt -> Y+4
;	i -> R16,R17
;	accum -> R18,R19
	LDI  R18,0
	LDI  R19,0
	__GETWRN 16,17,0
_0x22:
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	CP   R16,R30
	CPC  R17,R31
	BRGE _0x23
	MOVW R30,R16
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	LDI  R31,0
	__EORWRR 18,19,30,31
;     350 	return(accum & 0xff);
	__ADDWRN 16,17,1
	RJMP _0x22
_0x23:
	MOVW R30,R18
	ANDI R31,HIGH(0xFF)
	CALL __LOADLOCR4
	ADIW R28,8
	RET
;     351 }
;     352 
;     353 // ============================ COM2 1Ʈ ۽ ===========================
;     354 // [μ] char c
;     355 // Item1  ۽ 
;     356 // ----------------------------------------------------------------------------
;     357 void putchar1(char c)
;     358 {
_putchar1:
;     359 	while((UCSR1A & DATA_REGISTER_EMPTY)==0);
;	c -> Y+0
_0x24:
	LDS  R30,155
	ANDI R30,LOW(0x20)
	BREQ _0x24
;     360 	UDR1 = c;
	LD   R30,Y
	STS  156,R30
;     361 }
	ADIW R28,1
	RET

_getchar:
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
	RET
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET
__put_G2:
	ST   -Y,R17
	ST   -Y,R16
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	CALL __GETW1P
	SBIW R30,0
	BREQ _0x27
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CALL __GETW1P
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x29
	__CPWRN 16,17,2
	BRLO _0x2A
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	ST   X+,R30
	ST   X,R31
_0x29:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	SBIW R30,1
	LDD  R26,Y+6
	STD  Z+0,R26
_0x2A:
	RJMP _0x2B
_0x27:
	LDD  R30,Y+6
	ST   -Y,R30
	CALL _putchar
_0x2B:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,7
	RET
__print_G2:
	SBIW R28,6
	CALL __SAVELOCR6
	LDI  R17,0
_0x2C:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ADIW R30,1
	STD  Y+18,R30
	STD  Y+18+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+3
	JMP _0x2E
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x32
	CPI  R18,37
	BRNE _0x33
	LDI  R17,LOW(1)
	RJMP _0x34
_0x33:
	CALL SUBOPT_0x6
_0x34:
	RJMP _0x31
_0x32:
	CPI  R30,LOW(0x1)
	BRNE _0x35
	CPI  R18,37
	BRNE _0x36
	CALL SUBOPT_0x6
	RJMP _0x8A
_0x36:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x37
	LDI  R16,LOW(1)
	RJMP _0x31
_0x37:
	CPI  R18,43
	BRNE _0x38
	LDI  R20,LOW(43)
	RJMP _0x31
_0x38:
	CPI  R18,32
	BRNE _0x39
	LDI  R20,LOW(32)
	RJMP _0x31
_0x39:
	RJMP _0x3A
_0x35:
	CPI  R30,LOW(0x2)
	BRNE _0x3B
_0x3A:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x3C
	ORI  R16,LOW(128)
	RJMP _0x31
_0x3C:
	RJMP _0x3D
_0x3B:
	CPI  R30,LOW(0x3)
	BREQ PC+3
	JMP _0x31
_0x3D:
	CPI  R18,48
	BRLO _0x40
	CPI  R18,58
	BRLO _0x41
_0x40:
	RJMP _0x3F
_0x41:
	MOV  R26,R21
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOVW R30,R0
	MOV  R21,R30
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x31
_0x3F:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x45
	CALL SUBOPT_0x7
	LD   R30,X
	CALL SUBOPT_0x8
	RJMP _0x46
_0x45:
	CPI  R30,LOW(0x73)
	BRNE _0x48
	CALL SUBOPT_0x7
	CALL SUBOPT_0x9
	CALL _strlen
	MOV  R17,R30
	RJMP _0x49
_0x48:
	CPI  R30,LOW(0x70)
	BRNE _0x4B
	CALL SUBOPT_0x7
	CALL SUBOPT_0x9
	CALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x49:
	ORI  R16,LOW(2)
	ANDI R16,LOW(127)
	LDI  R19,LOW(0)
	RJMP _0x4C
_0x4B:
	CPI  R30,LOW(0x64)
	BREQ _0x4F
	CPI  R30,LOW(0x69)
	BRNE _0x50
_0x4F:
	ORI  R16,LOW(4)
	RJMP _0x51
_0x50:
	CPI  R30,LOW(0x75)
	BRNE _0x52
_0x51:
	LDI  R30,LOW(_tbl10_G2*2)
	LDI  R31,HIGH(_tbl10_G2*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(5)
	RJMP _0x53
_0x52:
	CPI  R30,LOW(0x58)
	BRNE _0x55
	ORI  R16,LOW(8)
	RJMP _0x56
_0x55:
	CPI  R30,LOW(0x78)
	BREQ PC+3
	JMP _0x87
_0x56:
	LDI  R30,LOW(_tbl16_G2*2)
	LDI  R31,HIGH(_tbl16_G2*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(4)
_0x53:
	SBRS R16,2
	RJMP _0x58
	CALL SUBOPT_0x7
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,0
	BRGE _0x59
	CALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R20,LOW(45)
_0x59:
	CPI  R20,0
	BREQ _0x5A
	SUBI R17,-LOW(1)
	RJMP _0x5B
_0x5A:
	ANDI R16,LOW(251)
_0x5B:
	RJMP _0x5C
_0x58:
	CALL SUBOPT_0x7
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
_0x5C:
_0x4C:
	SBRC R16,0
	RJMP _0x5D
_0x5E:
	CP   R17,R21
	BRSH _0x60
	SBRS R16,7
	RJMP _0x61
	SBRS R16,2
	RJMP _0x62
	ANDI R16,LOW(251)
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0x63
_0x62:
	LDI  R18,LOW(48)
_0x63:
	RJMP _0x64
_0x61:
	LDI  R18,LOW(32)
_0x64:
	CALL SUBOPT_0x6
	SUBI R21,LOW(1)
	RJMP _0x5E
_0x60:
_0x5D:
	MOV  R19,R17
	SBRS R16,1
	RJMP _0x65
_0x66:
	CPI  R19,0
	BREQ _0x68
	SBRS R16,3
	RJMP _0x69
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,1
	LPM  R30,Z
	RJMP _0x8B
_0x69:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x8B:
	ST   -Y,R30
	CALL SUBOPT_0xA
	CPI  R21,0
	BREQ _0x6B
	SUBI R21,LOW(1)
_0x6B:
	SUBI R19,LOW(1)
	RJMP _0x66
_0x68:
	RJMP _0x6C
_0x65:
_0x6E:
	LDI  R18,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,2
	CALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
_0x70:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x72
	SUBI R18,-LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R30,R26
	SBC  R31,R27
	STD  Y+10,R30
	STD  Y+10+1,R31
	RJMP _0x70
_0x72:
	CPI  R18,58
	BRLO _0x73
	SBRS R16,3
	RJMP _0x74
	SUBI R18,-LOW(7)
	RJMP _0x75
_0x74:
	SUBI R18,-LOW(39)
_0x75:
_0x73:
	SBRC R16,4
	RJMP _0x77
	CPI  R18,49
	BRSH _0x79
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,1
	BRNE _0x78
_0x79:
	RJMP _0x8C
_0x78:
	CP   R21,R19
	BRLO _0x7D
	SBRS R16,0
	RJMP _0x7E
_0x7D:
	RJMP _0x7C
_0x7E:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x7F
	LDI  R18,LOW(48)
_0x8C:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x80
	ANDI R16,LOW(251)
	ST   -Y,R20
	CALL SUBOPT_0xA
	CPI  R21,0
	BREQ _0x81
	SUBI R21,LOW(1)
_0x81:
_0x80:
_0x7F:
_0x77:
	CALL SUBOPT_0x6
	CPI  R21,0
	BREQ _0x82
	SUBI R21,LOW(1)
_0x82:
_0x7C:
	SUBI R19,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,2
	BRLO _0x6F
	RJMP _0x6E
_0x6F:
_0x6C:
	SBRS R16,0
	RJMP _0x83
_0x84:
	CPI  R21,0
	BREQ _0x86
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	CALL SUBOPT_0x8
	RJMP _0x84
_0x86:
_0x83:
_0x87:
_0x46:
_0x8A:
	LDI  R17,LOW(0)
_0x31:
	RJMP _0x2C
_0x2E:
	CALL __LOADLOCR6
	ADIW R28,20
	RET
_sprintf:
	PUSH R15
	CALL SUBOPT_0xB
	MOVW R26,R28
	ADIW R26,6
	CALL SUBOPT_0xC
	STD  Y+2,R30
	STD  Y+2+1,R31
	MOVW R26,R28
	ADIW R26,4
	CALL SUBOPT_0xC
	CALL SUBOPT_0xD
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(0)
	ST   X,R30
	RJMP _0x88
_printf:
	PUSH R15
	CALL SUBOPT_0xB
	LDI  R30,0
	STD  Y+2,R30
	STD  Y+2+1,R30
	MOVW R26,R28
	ADIW R26,4
	CALL SUBOPT_0xC
	CALL SUBOPT_0xD
_0x88:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,4
	POP  R15
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x0:
	MOVW R30,R8
	ADIW R30,1
	MOVW R8,R30
	SBIW R30,1
	SUBI R30,LOW(-_com2_rx_data)
	SBCI R31,HIGH(-_com2_rx_data)
	ST   Z,R16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1:
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0,0
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x2:
	CALL __CWD1
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:33 WORDS
SUBOPT_0x3:
	MOVW R30,R16
	__ADDWRN 16,17,1
	MOVW R26,R28
	ADIW R26,6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4:
	ADD  R30,R26
	ADC  R31,R27
	LDD  R26,Y+56
	STD  Z+0,R26
	RJMP SUBOPT_0x3

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x5:
	ADD  R30,R26
	ADC  R31,R27
	LDD  R26,Y+57
	STD  Z+0,R26
	RJMP SUBOPT_0x3

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:24 WORDS
SUBOPT_0x6:
	ST   -Y,R18
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,15
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x7:
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	SBIW R26,4
	STD  Y+16,R26
	STD  Y+16+1,R27
	ADIW R26,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x8:
	ST   -Y,R30
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,15
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x9:
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xA:
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,15
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xB:
	MOV  R15,R24
	SBIW R28,2
	ST   -Y,R17
	ST   -Y,R16
	MOVW R26,R28
	CALL __ADDW2R15
	MOVW R16,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xC:
	CALL __ADDW2R15
	CALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0xD:
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	JMP  __print_G2

_strlen:
	ld   r26,y+
	ld   r27,y+
	clr  r30
	clr  r31
__strlen0:
	ld   r22,x+
	tst  r22
	breq __strlen1
	adiw r30,1
	rjmp __strlen0
__strlen1:
	ret

_strlenf:
	clr  r26
	clr  r27
	ld   r30,y+
	ld   r31,y+
__strlenf0:
	lpm  r0,z+
	tst  r0
	breq __strlenf1
	adiw r26,1
	rjmp __strlenf0
__strlenf1:
	movw r30,r26
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	COM  R30
	COM  R31
	ADIW R30,1
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
